/*------------------------------------------------------------------------------
 lib/djv_base/app.h
 
 Command Line Application
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_APP_H
#define DJV_APP_H

#include <djv_base/base.h>

namespace djv {
namespace app {

class App {
public:

  App(const Str & name, int & argc, char ** argv);
  virtual ~App();
  
  // Execution.

  virtual int exec() { return exit(); }
  void exit(int);
  int exit() const { return _exit; }

  // Command line.

  bool cmdln(int &, char **);
  
  // Information.
  
  const Str & name() const { return _name; }
  const Str & argv0() const { return _argv0; }
  virtual Str info() const;
  virtual Str about() const;
  virtual Str help() const;
  
  // Messages.

  virtual void message(const Str &) const;
  virtual void error(const Str &) const;
  virtual void error(const Error &) const;
  virtual void print(const Str &, bool newline = true) const;
  virtual void separator() const;

private:

  int _exit;
  Str _name, _argv0;
  bool _endline, _separator;
};

// Global.

App * app();

}
}

#endif

