/*------------------------------------------------------------------------------
 lib/djv_base/file_info_.h
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include <djv_base/math.h>

namespace djv {
namespace file {

inline bool File::seq_add(const File & in)
{
  // Compare file name components.
  
  if (_extension != in._extension) return false;
  if (_base != in._base) return false;

  // Update sequence.
  
  seq.start = math::min(seq.start, in.seq.start);
  seq.end = math::max(seq.end, in.seq.end);
  seq.pad = math::max(seq.pad, in.seq.pad);

  // Update file information.
  
  size += in.size;
  user = math::max(user, in.user);
  time = math::max(time, in.time);

  return true;
}

inline bool File::seq_valid() const
{
  return type != DIR && ! number().empty();
}

inline int str_to_frame(const Str & in, int * pad)
{
  if (pad) {
    *pad = 0;
    const size_t size = in.size();
    if (size > 1) if (in[0] == '0') *pad = int(size);
  }
  return str::str_to_int(in);
}

}
}

