/*------------------------------------------------------------------------------
 lib/djv_image/base.h
 
 Base
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_IMAGE_BASE_H
#define DJV_IMAGE_BASE_H

#include <djv_base/base.h>
#include <GL/glew.h>
#if defined(WIN32)
#include <GL/wglew.h>
#elif defined(DJV_OSX)
#else
#include <GL/glxew.h>
#endif

namespace djv {
namespace image {

// Forward declarations.

namespace color { class Color; }
using color::Color;

namespace data { class Info; class Data; }
using data::Data;

class Info;
class Image;

namespace gl {
namespace pbuffer { class Pbuffer; }
namespace data { struct Options; class Data; }
}

namespace io {
class Info;
class Plugin;
class Load;
class Save;
class Load_Factory;
class Save_Factory;
}

}
}

#endif

