/*------------------------------------------------------------------------------
 lib/djv_image/gl_data_gradient.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_image/gl_data_gradient.cxx"

#include "image.h"
#include <djv_image/gl_pbuffer.h>

namespace djv {
namespace image {
namespace gl {
namespace data {

void gradient(image::Data * out) throw (Error)
{
  DJV_ASSERT(out);

  DJV_DBG_OBJ2(_DBG, "gradient");
  DJV_DBG_PRN("out = " << *out);
  
  const image::Info info(out->size(), pixel::L_F32);
  out->set(info);
  
  for (int y = 0; y < info.size.y; ++y) {
    pixel::F32_T * p = reinterpret_cast<pixel::F32_T *>(out->data(0, y));
    for (int x = 0; x < info.size.x; ++x, ++p)
      *p = x / double(info.size.x - 1);
  }
}

}
}
}
}

