/*------------------------------------------------------------------------------
 lib/djv_image/image.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "image.h"

namespace djv {
namespace image {

Image::Image() {}

Image::Image(const Info & in, const uint8_t * data)
{
  set(in, data);
}

void Image::set(const Info & in, const uint8_t * data)
{
  _info = in;
  
  Data::set(_info, data);
}

void Image::tag(const tag::Tag & in)
{
  _info.tag = in;
}

void Image::profile(const profile::Profile & in)
{
  _info.profile = in;
}

Dbg & operator << (Dbg & dbg, const Info & in)
  { return dbg << data::Info(in) <<
      " profile=" << in.profile.type; }

Dbg & operator << (Dbg & dbg, const Image & in) { return dbg << in.info(); }

}
}

