/*------------------------------------------------------------------------------
 lib/djv_ui/file.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "file.h"
#include <djv_ui/layout_row.h>
#include <djv_ui/button.h>
#include <djv_ui/text.h>
#include <djv_ui/file_browser.h>

namespace djv {
namespace ui {
namespace file {

Widget::Widget()
{
  // Widgets.
  
  _widget = new text::Edit;
  
  button::Push * dialog_widget = new button::Push("&Browse");
  
  // Layout.
  
  layout::Horizontal * layout = new layout::Horizontal(this);
  layout->margin(0);
  
  layout->add(_widget);
  layout->stretch(_widget);
  
  layout->add(dialog_widget);
  
  // Initialize.
  
  widget_update();

  // Callbacks.
  
  _widget->sig.set(this, widget_callback);
  dialog_widget->sig.set(this, dialog_callback);
}

void Widget::set(const File & in)
{
  if (in == _value) return;
  _value = in;
  widget_update();
  sig.emit(_value);
}

void Widget::widget_callback(const Str & in) { set(in); }

void Widget::dialog_callback(bool) { file_browser::set(this, dialog_callback); }
void Widget::dialog_callback(const File & in) { set(in); }

void Widget::widget_update() { _widget->set(_value); }

}
}
}

