/*------------------------------------------------------------------------------
 lib/djv_ui/gl.h
 
 OpenGL Widget

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_GL_H
#define DJV_UI_GL_H

#include <djv_image/gl.h>
#include <djv_ui/widget.h>
#include <FL/Fl_Gl_Window.H>

namespace djv {
namespace ui {
namespace gl {

class Widget : public Fl_Gl_Window, public widget::Base {
public:

  Widget();
  virtual ~Widget() {}
  
  // Widget.
  
  virtual int handle(int);
  virtual void draw();
  
  // Layout.
  
  virtual void resize(int, int, int, int);
  virtual Vec2i size_hint() const { return _size_hint; }
  virtual int visible() const { return Fl_Gl_Window::visible(); }

private:
  
  bool _init;
  Vec2i _size_hint;
};

}
}
}

#endif
