/*------------------------------------------------------------------------------
 lib/djv_ui/icon.h
 
 Icons
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_ICON_H
#define DJV_UI_ICON_H

#include <djv_ui/base.h>
#include <map>

namespace djv {
namespace ui {
namespace icon {

class Factory {
public:

  Factory();
  ~Factory();

  void add(const Str & name, Fl_Image *);
  
  // XXX FLTK should return a const pointer.
  
  Fl_Image * get(const Str & name) const;

private:

  typedef std::map<Str, Fl_Image *> List;
  
  List _list;
  Fl_Image _empty;
};

// Global.

Fl_Image * get(const Str & name);

void del();

}
}
}

#endif

