/*------------------------------------------------------------------------------
 lib/djv_ui/layout_stack.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_ui/layout_stack.cxx"

#include "layout_stack.h"

namespace djv {
namespace ui {
namespace layout {

Stack::Stack(Item * parent) :
  Layout(parent)
{}

void Stack::dirty()
{
  Layout::dirty();
  
  Vec2i size;
  const List<Item *> & list = this->list();
  for (uint i = 0; i < list.size(); ++i)
    size = vec::max(list[i]->size_hint(), size);
  
  _size_hint = size + margin() * 2;
}

void Stack::resize(int x, int y, int w, int h)
{
  DJV_DBG_OBJ2(_DBG, "Stack::resize");
  DJV_DBG_PRN("in = " << Box2i(x, y, w, h));

  Layout::resize(x, y, w, h);
  
  const List<Item *> & list = this->list();
  for (uint i = 0; i < list.size(); ++i)
    list[i]->resize(x + margin(), y + margin(), w - margin() * 2,
      h - margin() * 2);
}

}
}
}
