/*------------------------------------------------------------------------------
 plugin/djv_exr/fnc.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "plugin.h"
#include <djv_base/box.h>

using namespace image;

Box2i box(const Imath::Box2i & in)
{
  return Box2i(
    Vec2i(in.min.x, in.min.y),
    Vec2i(in.max.x, in.max.y) - Vec2i(in.min.x, in.min.y) + 1);
}

const List<Str> & color_label()
{
  static const List<Str> data = List<Str>() << "Raw" << "Exposure";
  return data;
}

const List<Str> & compress_label()
{
  static const List<Str> data = List<Str>() << "None" << "PIZ" << "ZIP" <<
    "RLE";
  return data;
}

const List<Str> & tag_label()
{
  static const List<Str> data = List<Str>() << "Longitude" << "Latitude" <<
    "Altitude" << "Focus" << "Exposure" << "Aperture" << "ISO Speed" <<
    "Chromaticities" << "White Luminance" << "X Density";
  return data;
}

const List<Str> & load_option_label()
{
  static const List<Str> data = List<Str>() << "Color" << "Exposure";
  return data;
}

const List<Str> & save_option_label()
{
  static const List<Str> data = List<Str>() << "Compress";
  return data;
}

