/*------------------------------------------------------------------------------
 plugin/djv_exr/ui.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_EXR_UI_H
#define DJV_EXR_UI_H

#include "plugin.h"
#include <djv_ui/image_io.h>

class Load_Widget : public ui::image_io::Load {
public:

  Load_Widget();

  Str name() const { return ::plugin_name; }
  Plugin * copy() const { return new Load_Widget; }

  void set(image::io::Plugin *);
  
private:

  DJV_CALLBACK(Load_Widget, color_callback, int);
  DJV_CALLBACK(Load_Widget, exposure_callback, double);
  DJV_CALLBACK(Load_Widget, defog_callback, double);
  DJV_CALLBACK(Load_Widget, knee_low_callback, double);
  DJV_CALLBACK(Load_Widget, knee_high_callback, double);
  DJV_CALLBACK(Load_Widget, gamma_callback, double);
  
  void plugin_update();
  void widget_update();
  
  image::io::Plugin * _plugin;
  ::Load::Options _options;
  ui::choice::Widget * _color_widget;
  ui::num::Float_Slider * _exposure_widget, * _defog_widget,
    * _knee_low_widget, * _knee_high_widget, * _gamma_widget;
};

class Save_Widget : public ui::image_io::Save {
public:

  Save_Widget();

  Str name() const { return ::plugin_name; }
  Plugin * copy() const { return new Save_Widget; }

  void set(image::io::Plugin *);
  
private:

  DJV_CALLBACK(Save_Widget, compress_callback, int);
  
  void plugin_update();
  void widget_update();

  image::io::Plugin * _plugin;
  ::Save::Options _options;
  ui::choice::Widget * _compress_widget;
};

#endif
