/*------------------------------------------------------------------------------
 plugin/djv_vlut/fnc.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "plugin/djv_vlut/fnc.cxx"

#include "plugin.h"

Handle::Handle(const Str & name) throw (Error)

#if defined(DJV_VLUT_XORG) || defined (DJV_VLUT_XSGI)

  : display(0), screen(0)

#elif defined(DJV_VLUT_WIN32)
  
  : display(0)

#endif
{
  DJV_DBG_OBJ2(_DBG, "Handle::Handle");
  
#if defined(DJV_VLUT_XORG) || defined (DJV_VLUT_XSGI)

  display = ::XOpenDisplay(name.c_str());
  if (! display)
    throw Error(plugin_name, image::io::error_open);
  
  screen = DefaultScreen(display);

#elif defined(DJV_VLUT_WIN32)

  display = ::GetDC(0);
  if (! display)
    throw Error(plugin_name, image::io::error_open);

#endif
}

Handle::~Handle()
{
#if defined(DJV_VLUT_XORG) || defined (DJV_VLUT_XSGI)

  if (display) ::XCloseDisplay(display);

#elif defined(DJV_VLUT_WIN32)

  if (display) ::ReleaseDC(0, display);

#endif
}

